﻿Imports System.IO
Imports System.Xml
'Version 2.0.0.0
'   Niet betaalde facturen worden in de file "StratoBankFacturenNietBetaald.csv" geplaatst.
'   Deze file kan dan met de optie "nog niet betaald" in Acumulus geïmporteerd worden.

Public Class Form1
    Private StratoFile As StreamReader
    Private AcumulusFile As StreamWriter
    Private AcumulusFileBank As StreamWriter
    Private AcumulusFileBankNP As StreamWriter
    Private AcumulusFilePayPal As StreamWriter

    Private Enum OrderStatus As Integer
        Paid
        NotPaid
        NotInvoiced
    End Enum
    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        ToolStripStatusLabel1.Text = "Version: " & My.Application.Info.Version.Major.ToString & "." &
    My.Application.Info.Version.Minor.ToString & "." &
    My.Application.Info.Version.Build.ToString & "." &
    My.Application.Info.Version.Revision.ToString
    End Sub

    Private Sub ButtonKlanten_Click(sender As Object, e As EventArgs) Handles ButtonKlanten.Click
        Dim OpenFileDialog1 As New OpenFileDialog()
        Dim SaveFileDialog1 As New SaveFileDialog()
        Dim fs As FileStream = Nothing
        Dim Infile, Outfile, strInData, strOutData, strFields(90) As String

        OpenFileDialog1.Title = "Open input file: Strato klanten csv"
        OpenFileDialog1.FileName = "Klanten.csv"
        OpenFileDialog1.Filter = "Text files (*.csv)|*.csv|All files (*.*)|*.*"
        If OpenFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            Infile = OpenFileDialog1.FileName

            SaveFileDialog1.Title = "Open output file: Acumulus klanten csv"
            SaveFileDialog1.FileName = "AcumulusKlanten.csv"
            SaveFileDialog1.Filter = "Text files (*.csv)|*.csv|All files (*.*)|*.*"
            If SaveFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
                Outfile = SaveFileDialog1.FileName
                Try
                    StratoFile = New StreamReader(Infile)
                    strInData = StratoFile.ReadLine() 'skip Strato header line

                    fs = New FileStream(Outfile, FileMode.Create)
                    AcumulusFile = New StreamWriter(fs)

                    AcumulusFile.Write("""(Bedrijfs)Naam1"";""(Bedrijfs)Naam2"";""Contactpersoon"";""Aanhef"";""Adres1"";""Adres2"";""Postcode"";""Plaats"";""Land"";""Telefoon"";""Fax"";""Email-adres"";""Website"";""Rekening"";""IBAN"";""SWIFT BIC"";""Landcode"";""BTW-nummer"";""BTW percentage"";""Type nr"";""Relatie Type"";""Kenmerk"";""Actief"";""Eigen referentie"";""Incasso type"";""Mandaat nr"";""Mandaat_datum"";""relatie ID"";""Factuursjabloon""" & Chr(10))

                    Do While Not StratoFile.EndOfStream
                        strInData = StratoFile.ReadLine()
                        strInData = strInData.Replace("""", "")

                        strFields = Split(strInData, ";")
                        If strFields(26) <> "" Then
                            strOutData = """" & strFields(26) & """;"    '1 (Bedrijfs)Naam1
                        Else
                            strOutData = """" & strFields(14) & " "
                            If strFields(15) <> "" Then
                                strOutData &= strFields(15) & " "
                            End If
                            strOutData &= strFields(16) & """;"
                        End If
                        strOutData &= """"";"                        '2 (Bedrijfs)Naam2
                        strOutData &= """" & strFields(17) & """;"   '3 Contactpersoon
                        strOutData &= """" & strFields(12) & """;"   '4 Aanhef
                        strOutData &= """" & strFields(19) & """;"   '5 Adres1
                        strOutData &= """" & strFields(20) & """;"   '6 Adres2
                        strOutData &= """" & strFields(22) & """;"   '7 Postcode
                        strOutData &= """" & strFields(23) & """;"   '8 Plaats
                        strOutData &= """" & strFields(24) & """;"   '9 Land
                        strOutData &= """" & strFields(31) & """;"   '10 Telefoon
                        strOutData &= """" & strFields(35) & """;"   '11 Fax
                        strOutData &= """" & strFields(36) & """;"   '12 Email-adres
                        strOutData &= """" & strFields(40) & """;"   '13 Website
                        strOutData &= """"";"                        '14 Rekening
                        strOutData &= """" & strFields(42) & """;"   '15 IBAN
                        strOutData &= """" & strFields(43) & """;"   '16 SWIFT BIC
                        strOutData &= """" & strFields(24) & """;"   '17 Landcode
                        strOutData &= """" & strFields(27) & """;"   '18 BTW-nummer
                        If strFields(24) = "NL" Then
                            strOutData &= """21.00"";"           '19 BTW percentage
                        ElseIf InStr(strFields(2).ToLower, "klant") Then
                            strOutData &= """21.00"";"           '19 BTW percentage
                        Else
                            strOutData &= """0"";"              '19 BTW percentage
                        End If
                        strOutData &= """1"";"                  '20 type   
                        strOutData &= """" & strFields(2) & """;"    '21 Relatie type
                        strOutData &= """"";"                   '22 Kenmerk
                        strOutData &= """ja"";"                 '23 Actief
                        strOutData &= """" & strFields(1) & """;"    '24 Eigen referentie
                        strOutData &= """FRST"";"               '25 Incasso type
                        strOutData &= """"";"                   '26 Mandaat nr
                        strOutData &= """"";"                   '27 Mandaat_datum
                        strOutData &= """" & strFields(1) & """;"    '28 Relatie ID
                        strOutData &= """Standaard"""          '29 Factuursjabloon

                        AcumulusFile.Write(strOutData & Chr(10))
                    Loop

                    StratoFile.Close()
                    AcumulusFile.Close()

                    TextBox1.AppendText("Output file " & Outfile & " created" & Chr(13) & Chr(10))
                Catch ex As Exception
                    TextBox1.AppendText("Exception:" & ex.Message)
                    Exit Sub
                End Try
            End If
        End If
    End Sub

    Private Sub ButtonFacturen_Click(sender As Object, e As EventArgs) Handles ButtonFacturen.Click
        Dim xmlDoc As New XmlDocument()
        Dim nodes As XmlNodeList
        Dim myNode As XmlNode
        Dim OpenFileDialog1 As New OpenFileDialog()
        Dim SaveFileDialog1 As New SaveFileDialog()
        Dim Temp, Infile, OutfileBank, OutfileBankNP, OutfilePayPal, strOutData As String
        Dim datum, debiteur_naam1, debiteur_naam2, debiteur_adres1, debiteur_adres2, debiteur_postcode, debiteur_plaats As String
        Dim debiteur_email, factuurnummer, product_btw_tarief, product_subtotaal_ex_btw, product_subtotaal_in_btw As String
        Dim factuur_typenummer, debiteur_land, vatid, betaling, order As String
        Dim intBank, intBankNP, intPayPal, intOrderStatus As Integer

        intBank = 0
        intBankNP = 0
        intPayPal = 0


        OpenFileDialog1.Title = "Open input file: Strato bestellingen xml"
        OpenFileDialog1.FileName = "Bestellingen.xml"
        OpenFileDialog1.Filter = "XML files (*.xml)|*.xml|All files (*.*)|*.*"
        If OpenFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
            Infile = OpenFileDialog1.FileName
            xmlDoc.Load(Infile)

            SaveFileDialog1.Title = "Open output file: Strato bankfacturen csv"
            SaveFileDialog1.FileName = "StratoBankFacturen.csv"
            SaveFileDialog1.Filter = "Text files (*.csv)|*.csv|All files (*.*)|*.*"
            If SaveFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
                OutfileBank = SaveFileDialog1.FileName
                AcumulusFileBank = New StreamWriter(OutfileBank)

                SaveFileDialog1.Title = "Open output file: Strato niet betaalde bankfacturen csv"
                SaveFileDialog1.FileName = "StratoBankFacturenNietBetaald.csv"
                SaveFileDialog1.Filter = "Text files (*.csv)|*.csv|All files (*.*)|*.*"
                If SaveFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
                    OutfileBankNP = SaveFileDialog1.FileName
                    AcumulusFileBankNP = New StreamWriter(OutfileBankNP)

                    SaveFileDialog1.Title = "Open output file: Strato PayPal facturen csv"
                    SaveFileDialog1.FileName = "StratoPayPalFacturen.csv"
                    SaveFileDialog1.Filter = "Text files (*.csv)|*.csv|All files (*.*)|*.*"
                    If SaveFileDialog1.ShowDialog() = System.Windows.Forms.DialogResult.OK Then
                        OutfilePayPal = SaveFileDialog1.FileName
                        AcumulusFilePayPal = New StreamWriter(OutfilePayPal)

                        Try
                            AcumulusFilePayPal.WriteLine("datum;debiteur_naam1;debiteur_naam2;debiteur_adres1;debiteur_adres2;debiteur_postcode;debiteur_plaats;debiteur_email;gebruik_bestaande_debiteur;factuurID;factuurnummer;product_omschrijving;product_prijs_per_eenheid_ex_btw;product_btw_tarief;product_aantal;product_subtotaal_ex_btw;product_subtotaal_in_btw;factuur_typenummer;debiteur_land;btw_nummer;ICP soort")
                            AcumulusFileBank.WriteLine("datum;debiteur_naam1;debiteur_naam2;debiteur_adres1;debiteur_adres2;debiteur_postcode;debiteur_plaats;debiteur_email;gebruik_bestaande_debiteur;factuurID;factuurnummer;product_omschrijving;product_prijs_per_eenheid_ex_btw;product_btw_tarief;product_aantal;product_subtotaal_ex_btw;product_subtotaal_in_btw;factuur_typenummer;debiteur_land;btw_nummer;ICP soort")
                            AcumulusFileBankNP.WriteLine("datum;debiteur_naam1;debiteur_naam2;debiteur_adres1;debiteur_adres2;debiteur_postcode;debiteur_plaats;debiteur_email;gebruik_bestaande_debiteur;factuurID;factuurnummer;product_omschrijving;product_prijs_per_eenheid_ex_btw;product_btw_tarief;product_aantal;product_subtotaal_ex_btw;product_subtotaal_in_btw;factuur_typenummer;debiteur_land;btw_nummer;ICP soort")

                            nodes = xmlDoc.DocumentElement.SelectNodes("/Orders/Order")

                            For Each node As XmlNode In nodes
                                myNode = node.SelectSingleNode("OrderNumber")
                                If Not IsNothing(myNode) Then
                                    order = node.SelectSingleNode("OrderNumber").InnerText
                                Else
                                    order = "?"
                                End If

                                myNode = node.SelectSingleNode("PaidOn")
                                If Not IsNothing(myNode) Then
                                    datum = Mid(node.SelectSingleNode("PaidOn").InnerText, 1, 10)
                                    intOrderStatus = OrderStatus.Paid
                                Else
                                    myNode = node.SelectSingleNode("InvoicedOn")
                                    If Not IsNothing(myNode) Then
                                        datum = Mid(node.SelectSingleNode("InvoicedOn").InnerText, 1, 10)
                                        intOrderStatus = OrderStatus.NotPaid
                                    Else
                                        datum = ""
                                        intOrderStatus = OrderStatus.NotInvoiced
                                    End If
                                End If

                                myNode = node.SelectSingleNode("Addresses/BillingAddress/Company")
                                If Not IsNothing(myNode) Then
                                    debiteur_naam1 = node.SelectSingleNode("Addresses/BillingAddress/Company").InnerText
                                    myNode = node.SelectSingleNode("Addresses/BillingAddress/FirstName")
                                    If Not IsNothing(myNode) Then
                                        debiteur_naam2 = node.SelectSingleNode("Addresses/BillingAddress/FirstName").InnerText & " "
                                    Else
                                        debiteur_naam2 = ""
                                    End If
                                    myNode = node.SelectSingleNode("Addresses/BillingAddress/LastName")
                                    If Not IsNothing(myNode) Then
                                        debiteur_naam2 &= node.SelectSingleNode("Addresses/BillingAddress/LastName").InnerText
                                    End If
                                Else
                                    myNode = node.SelectSingleNode("Addresses/BillingAddress/FirstName")
                                    If Not IsNothing(myNode) Then
                                        debiteur_naam1 = node.SelectSingleNode("Addresses/BillingAddress/FirstName").InnerText & " "
                                    Else
                                        debiteur_naam1 = ""
                                    End If
                                    myNode = node.SelectSingleNode("Addresses/BillingAddress/LastName")
                                    If Not IsNothing(myNode) Then
                                        debiteur_naam1 &= node.SelectSingleNode("Addresses/BillingAddress/LastName").InnerText
                                    End If
                                    debiteur_naam2 = ""
                                End If

                                myNode = node.SelectSingleNode("Addresses/BillingAddress/Street")
                                If Not IsNothing(myNode) Then
                                    debiteur_adres1 = node.SelectSingleNode("Addresses/BillingAddress/Street").InnerText
                                Else
                                    debiteur_adres1 = ""
                                End If

                                debiteur_adres2 = ""

                                myNode = node.SelectSingleNode("Addresses/BillingAddress/Zipcode")
                                If Not IsNothing(myNode) Then
                                    debiteur_postcode = node.SelectSingleNode("Addresses/BillingAddress/Zipcode").InnerText
                                Else
                                    debiteur_postcode = ""
                                End If

                                myNode = node.SelectSingleNode("Addresses/BillingAddress/City")
                                If Not IsNothing(myNode) Then
                                    debiteur_plaats = node.SelectSingleNode("Addresses/BillingAddress/City").InnerText
                                Else
                                    debiteur_plaats = ""
                                End If

                                myNode = node.SelectSingleNode("Addresses/BillingAddress/EMail")
                                If Not IsNothing(myNode) Then
                                    debiteur_email = node.SelectSingleNode("Addresses/BillingAddress/EMail").InnerText
                                Else
                                    debiteur_email = ""
                                End If

                                myNode = node.SelectSingleNode("OrderDocuments/Invoices/Invoice/InvoiceNumber")
                                If Not IsNothing(myNode) Then
                                    factuurnummer = node.SelectSingleNode("OrderDocuments/Invoices/Invoice/InvoiceNumber").InnerText
                                Else
                                    factuurnummer = ""
                                End If

                                myNode = node.SelectSingleNode("TotalBeforeTax")
                                If Not IsNothing(myNode) Then
                                    product_subtotaal_ex_btw = node.SelectSingleNode("TotalBeforeTax").InnerText
                                Else
                                    product_subtotaal_ex_btw = "0"
                                End If

                                myNode = node.SelectSingleNode("GrandTotal")
                                If Not IsNothing(myNode) Then
                                    product_subtotaal_in_btw = node.SelectSingleNode("GrandTotal").InnerText
                                Else
                                    product_subtotaal_in_btw = "0"
                                End If

                                myNode = node.SelectSingleNode("LineItems/LineItem/TaxRate")
                                If Not IsNothing(myNode) Then
                                    product_btw_tarief = node.SelectSingleNode("LineItems/LineItem/TaxRate").InnerText
                                    If Not IsNumeric(product_btw_tarief) Then
                                        product_btw_tarief = "21"
                                    Else
                                        If product_btw_tarief <> 0 Then
                                            product_btw_tarief = "21"
                                        End If
                                    End If
                                Else
                                    product_btw_tarief = "0"
                                End If

                                myNode = node.SelectSingleNode("TaxArea")
                                If Not IsNothing(myNode) Then
                                    Temp = node.SelectSingleNode("TaxArea").InnerText
                                    If Temp = "EU" Or Temp = "Duitsland" Then 'TaxArea
                                        myNode = node.SelectSingleNode("TotalTax")
                                        If Not IsNothing(myNode) Then
                                            Temp = node.SelectSingleNode("TotalTax").InnerText
                                            If Temp <> 0 Then
                                                factuur_typenummer = "1"   '18 factuur_typenummer Gewone factuur (BTW-vrij, 6% of 21%);
                                            Else
                                                factuur_typenummer = "3"   '18 factuur_typenummer intracommunautaire levering
                                            End If
                                        Else
                                            factuur_typenummer = "1"    'Gewone factuur (BTW-vrij, 6% of 21%)
                                        End If
                                    Else
                                        factuur_typenummer = "4"   'factuur voor goederen buiten de EU
                                    End If
                                Else
                                    factuur_typenummer = "1"    'Gewone factuur (BTW-vrij, 6% of 21%)
                                End If


                                myNode = node.SelectSingleNode("Addresses/BillingAddress/Country")
                                If Not IsNothing(myNode) Then
                                    debiteur_land = node.SelectSingleNode("Addresses/BillingAddress/Country").InnerText
                                Else
                                    debiteur_land = ""
                                End If

                                myNode = node.SelectSingleNode("LineItems/LineItemPayment/Id")  'Paypal or bank
                                If Not IsNothing(myNode) Then
                                    betaling = node.SelectSingleNode("LineItems/LineItemPayment/Id").InnerText
                                Else
                                    betaling = "?"
                                End If

                                myNode = node.SelectSingleNode("Addresses/BillingAddress/VATID")
                                If Not IsNothing(myNode) Then
                                    vatid = node.SelectSingleNode("Addresses/BillingAddress/VATID").InnerText
                                Else
                                    vatid = ""
                                End If

                                    strOutData = datum & ";"
                                    strOutData &= debiteur_naam1 & ";"
                                strOutData &= debiteur_naam2 & ";"
                                strOutData &= debiteur_adres1 & ";"
                                strOutData &= debiteur_adres2 & ";"
                                strOutData &= debiteur_postcode & ";"
                                strOutData &= debiteur_plaats & ";"
                                strOutData &= debiteur_email & ";"
                                strOutData &= "1;"                            '9 gebruik_bestaande_debiteur
                                strOutData &= factuurnummer & ";"             '10 factuur ID
                                strOutData &= factuurnummer & ";"
                                strOutData &= "Strato order:" & order & ";"   '12 product_omschrijving
                                strOutData &= product_subtotaal_ex_btw & ";"  '13 product_prijs_per_eenheid_ex_btw;
                                strOutData &= product_btw_tarief & ";"
                                strOutData &= "1;"                            '15 product_aantal
                                strOutData &= product_subtotaal_ex_btw & ";"
                                strOutData &= product_subtotaal_in_btw & ";"
                                strOutData &= factuur_typenummer & ";"
                                strOutData &= debiteur_land & ";"
                                strOutData &= vatid & ";"
                                strOutData &= "Product"

                                Select Case intOrderStatus
                                    Case OrderStatus.Paid
                                        If betaling = "PayPal Websitebetalingen Express" Then
                                            AcumulusFilePayPal.WriteLine(strOutData)
                                            intPayPal += 1
                                        Else
                                            AcumulusFileBank.WriteLine(strOutData)
                                            intBank += 1
                                        End If

                                    Case OrderStatus.NotPaid
                                        TextBox1.AppendText("Order not paid: " & order & Chr(13) & Chr(10))
                                        AcumulusFileBankNP.WriteLine(strOutData)
                                        intBankNP += 1

                                    Case OrderStatus.NotInvoiced
                                        TextBox1.AppendText("Order skipped, because not invoiced: " & order & Chr(13) & Chr(10))

                                    Case Else
                                        TextBox1.AppendText("Program error: no OrderStatus" & Chr(13) & Chr(10))
                                End Select

                            Next


                            AcumulusFileBank.Close()
                            AcumulusFileBankNP.Close()
                            AcumulusFilePayPal.Close()

                            TextBox1.AppendText("Output file " & OutfileBank & " created with " & intBank.ToString & " records" & Chr(13) & Chr(10))
                            TextBox1.AppendText("Output file " & OutfileBankNP & " created with " & intBankNP.ToString & " records" & Chr(13) & Chr(10))
                            TextBox1.AppendText("Output file " & OutfilePayPal & " created with " & intPayPal.ToString & " records" & Chr(13) & Chr(10))

                        Catch ex As Exception
                            TextBox1.AppendText("Exception:" & ex.Message)
                            Exit Sub
                        End Try
                    End If
                End If
            End If
        End If
    End Sub

    Private Sub btnExit_Click(sender As Object, e As EventArgs) Handles btnExit.Click
        Me.Close()
        Application.Exit()
    End Sub
End Class
